// pub(crate) mod image {
//     use crate::image::Image;
//
//     pub fn bg() -> Image {
//         Image {
//             name: "bg".to_string(),
//             pixels: vec![
//                 0,0,0,0,0,0,0,0,
//                 0,0,0,0,0,0,0,0,
//                 0,0,0,0,0,0,0,0,
//                 0,0,0,0,0,0,0,0,
//                 0,0,0,0,0,0,0,0,
//                 0,0,0,0,0,0,0,0,
//                 0,0,0,0,0,0,0,0,
//                 0,0,0,0,0,0,0,0,
//             ]
//         }
//     }
//
//     pub fn block() -> Image {
//         Image {
//             name: "block".to_string(),
//             pixels: vec![
//                 1,1,1,1,1,1,1,1,
//                 1,0,0,0,0,0,0,1,
//                 1,0,0,0,0,0,0,1,
//                 1,0,0,1,1,0,0,1,
//                 1,0,0,1,1,0,0,1,
//                 1,0,0,0,0,0,0,1,
//                 1,0,0,0,0,0,0,1,
//                 1,1,1,1,1,1,1,1,
//             ]
//         }
//     }
//
//     pub fn avatar() -> Image {
//         Image {
//             name: "avatar".to_string(),
//             pixels: vec![
//                 0,0,0,2,2,0,0,0,
//                 0,0,0,2,2,0,0,0,
//                 0,0,0,2,2,0,0,0,
//                 0,0,2,2,2,2,0,0,
//                 0,2,2,2,2,2,2,0,
//                 2,0,2,2,2,2,0,2,
//                 0,0,2,0,0,2,0,0,
//                 0,0,2,0,0,2,0,0,
//             ]
//         }
//     }
//
//     pub fn cat() -> Image {
//         Image {
//             name: "cat".to_string(),
//             pixels: vec![
//                 0,0,0,0,0,0,0,0,
//                 0,0,0,0,0,0,0,0,
//                 0,2,0,2,0,0,0,2,
//                 0,2,2,2,0,0,0,2,
//                 0,2,2,2,0,0,2,0,
//                 0,2,2,2,2,2,0,0,
//                 0,0,2,2,2,2,0,0,
//                 0,0,2,0,0,2,0,0,
//             ]
//         }
//     }
// }

pub(crate) mod palette {
    use crate::{Palette, Colour};

    pub(crate) fn default() -> Palette {
        Palette {
            name: "blueprint".to_string(),
            colours: vec![
                Colour { red: 0,   green: 0,   blue: 0   },
                Colour { red: 0,   green: 81,  blue: 104 },
                Colour { red: 118, green: 159, blue: 155 },
                Colour { red: 155, green: 155, blue: 155 },
            ],
        }
    }

    pub(crate) fn soup11() -> Palette {
        Palette {
            name: "soup11".into(),
            colours: vec![
                Colour { red: 79, green: 30, blue: 69 },
                Colour { red: 150, green: 48, blue: 87 },
                Colour { red: 215, green: 68, blue: 89 },
                Colour { red: 235, green: 112, blue: 96 },
                Colour { red: 255, green: 179, blue: 131 },
                Colour { red: 255, green: 255, blue: 255 },
                Colour { red: 127, green: 227, blue: 187 },
                Colour { red: 92, green: 187, blue: 196 },
                Colour { red: 69, green: 126, blue: 163 },
                Colour { red: 56, green: 66, blue: 118 },
                Colour { red: 50, green: 36, blue: 81 }
            ]
        }
    }
}
